#ifndef DLGMAIN_H
#define DLGMAIN_H

#include "siteinfo.h"
#include <qbuttongroup.h>
#include <qcheckbox.h>
#include <qcombobox.h>
#include <qlabel.h>
#include <qlayout.h>
#include <qlineedit.h>
#include <qpainter.h>
#include <qpushbutton.h>
#include <qradiobutton.h>
#include <qtextedit.h>
#include <qtabwidget.h>
#include <qwidget.h>
#include "syncprocess.h"
#include "dlgsharelist.h"

class DlgMain : public QWidget {
		Q_OBJECT
	public:
		DlgMain(SiteInfo &si, QWidget *parent=0, const char *name=0);
		// should i FIXME? ~DlgMain();
	public slots:
		void updateInfo(SiteInfo &si);
	protected:
		virtual void paintEvent(QPaintEvent *event);
	private slots:
		void changeLocal(const QString &s);
		void changeHost(const QString &s);
		void changePort(const QString &s);
		void changePass(const QString &s);
		void changeRemote(const QString &s);
		void changeUser(const QString &s);
		void getDestination();
		void getSource();
		//void modeDownTgl(bool enabled);
		//void modeUpTgl(bool enabled);
		void remoteChosen(QString s);
		void runSync();
		void setAnonymous(bool checked);
		void setLocalhost(bool checked);
	private:
		// data
		SiteInfo *siteInfo;	// all data for current site
		bool minSizeSet;		// used for ensuring a minimum dialog size
		// goddamn labels.. extra clutter in here
		QLabel *siteListLbl, *hostPortLbl, *remoteLbl, *localLbl, *userPassLbl, *modeLbl, *commentLbl;
		// all other dialog widgets below
		QCheckBox *anonymousBtn;
		QHBoxLayout *boxUserPass;		// container for fields
		QTextEdit *commentEdit;
		QLineEdit *localEdit, *hostEdit, *passEdit, *portEdit, *userEdit, *remoteEdit;
		QPushButton *localSelBtn, *nextBtn, *prevBtn, *saveBtn, *remoteSelBtn, *startBtn;
		QGridLayout *gridLeft;
		QCheckBox *localhostBtn;		// localhost transfer only?
		QButtonGroup *modeBox;			// container
		QRadioButton *modeDownBtn;	// download mode
		QRadioButton *modeUpBtn;		// upload mode
		QVBoxLayout *gridRight;
		QCheckBox *rootPermBtn;			// use root perms?
		SyncProcess *syncProcess;	// actually does the work
		QComboBox *siteListBox;
		DlgShareList *shareListDlg;
		DlgStatus *statusDlg;
		QTabWidget *tabBar;
		QHBoxLayout *widgetLayout;
};

#endif /* DLGMAIN_H */
