#ifndef DLGSTATUS_H
#define DLGSTATUS_H

#include <qwidget.h>
#include <qlistview.h>
#include <qlayout.h>
#include <qheader.h>
#include <qdir.h>
#include <qprogressbar.h>
#include <qpushbutton.h>
#include <qstatusbar.h>
#include <qvbox.h>

class DlgStatus : public QWidget {
		Q_OBJECT
	public:
		DlgStatus(QWidget *parent=0, const char *name=0);
		void addListItem(QString item);
		void addTransferItem(QString name);
		void changeStatus(QString s);
		void clearRecvList();
		void clearTransList();
		void refreshLocal();
		void setCWD(QString dir);
		QString getCWD();
		void makeFileComplete();
		int setCurrFile(QString file);
	public slots:
		void setFileProgress(long size, int percent, QString rate, QString eta);
		void downloadClicked();
		void uploadClicked();
	signals:
		void syncViewDir(QString s);
		void syncGetFile(QString s);
		void syncSendFile(QString s);
	private:
		void fillLocalList();
		QDir *localDir;
		QGridLayout *gridMain;
		QPixmap *imgDownload;
		QPixmap *imgUpload;
		QListView *leftList, *rightList, *transferList;
		QListViewItem *currTransfer;
		QProgressBar *fileProgress;
		QPushButton *btnDownload, *btnUpload;
		QString nameHeader, permsHeader, originalDir;
		QStatusBar *statusBar;
		QVBox *operationsPanel;
	private slots:
		void localListDoubleClicked(QListViewItem *item);
		void remoteListDoubleClicked(QListViewItem *item);
		void remoteSelectChanged();
};

#endif /* DLGSTATUS_H */
